unit Autoldde;
{
  Esimerkki DDE-palvelimesta ja asiakkaasta.

  Vesa Lappalainen 18.11.1997

  DDE-palvelin: (server)
  ======================
    A)
      1) Lis TDdeServerConv.  Anna nimeksi vaikkapa Lkm
      2) Lis tarvittava mr TDdeServerItemeja.  Anna kuvaavia nimi,
         esim: HA, linkit 1)-kohdan Conv-komponenttiin.
      3) Lis niihin kohti, joissa sislt muuttuu koodi:
           HA.Text := uusi_teksti;
      4) Jos ohjelman nimi on vaikkapa AutolDDE, niin
         laita esim. Exceliss linkiksi AutolDDE|Lkm|HA   (Huom! Case)
    B)
      edelt 2)-3) (ei 1 lainkaan)
      4) Jos Lomakkeen otsikko on vaikkapa Autolaskuri, niin Excelin
         linkiksi AutolDDE|Autolaskuri|HA

  DDE-asiakas: (client)
  ======================
      1) Lis TDdeClientConv.
      2) Laita kohdeohjelmassa, esim. Exceliss haluttu asia leikepydlle.
      3) Klikkaa Conv-komponentin DdeService-propertia.
      4) Valitse PasteLink (Jos polku on turha, sy se pois)
      5) Lis tarvittava mr DdeServiceItem-komponentteja.
      6) Linkit Conv. kopmponenttiin
      7) laita DdeItem (esim. Excelin solu = R1C1)
      8) Ksittele Itemin Change-tapahtuma ja .Text -property
         haluamaasi kyttn.
      Leikekirjaan laittaminen ei toimi kuten helpiss luvataan!   

}
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, IvMulti, IvEMulti, IvFiMult, TeEngine, Series,
  ExtCtrls, DdeMan;

type
  TAutolaskuri = class(TForm)
    ButtonHA: TButton;
    ButtonKA: TButton;
    LabelHA: TLabel;
    LabelKA: TLabel;
    ButtonNollaa: TButton;
    HA: TDdeServerItem;
    ButtonClp: TButton;
    DdeClientConv1: TDdeClientConv;
    DdeExcel: TDdeClientItem;
    LabelDDE: TLabel;
    Lkm: TDdeServerConv;
    procedure ButtonHAClick(Sender: TObject);
    procedure ButtonNollaaClick(Sender: TObject);
    procedure ButtonKAClick(Sender: TObject);
    procedure ButtonClpClick(Sender: TObject);
    procedure DdeExcelChange(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
  end;

var
  Autolaskuri: TAutolaskuri;

implementation

{$R *.DFM}

procedure TAutolaskuri.ButtonHAClick(Sender: TObject);
begin
  LabelHA.Caption := IntToStr(StrToInt(LabelHA.Caption)+1);
  HA.Text := LabelHA.Caption;
end;

procedure TAutolaskuri.ButtonKAClick(Sender: TObject);
begin
  LabelKA.Caption := IntToStr(StrToInt(LabelKA.Caption)+1);
end;

procedure TAutolaskuri.ButtonNollaaClick(Sender: TObject);
begin
  LabelHA.Caption := '0';
  LabelKA.Caption := '0';
end;

procedure TAutolaskuri.ButtonClpClick(Sender: TObject);
begin
  HA.CopyToClipboard;
end;

procedure TAutolaskuri.DdeExcelChange(Sender: TObject);
begin
  LabelDDE.Caption := DdeExcel.Text;
end;

end.
